//
//  AlfordCTSCTPeripheral.h
//  nRF UART
//
//  Created by Ole Morten on 1/12/13.
//  Copyright (c) 2013 Nordic Semiconductor. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol AlfordCTSCTPeripheralDelegate
- (void) didReceiveData:(NSString *) string;
@optional
- (void) didReadHardwareRevisionString:(NSString *) string;
@end


@interface AlfordCTSCTPeripheral : NSObject <CBPeripheralDelegate>
@property CBPeripheral *peripheral;
@property (strong, nonatomic) CBCentralManager *CM; 
@property id<AlfordCTSCTPeripheralDelegate> delegate;
@property (strong, nonatomic)  NSMutableArray *peripherals;
+ (CBUUID *) CTSServiceUUID;

- (AlfordCTSCTPeripheral *) initWithPeripheral:(CBPeripheral*)peripheral delegate:(id<AlfordCTSCTPeripheralDelegate>) delegate;

- (void) writeAlarm:(NSData *) data;
- (void) writeCurrentTime:(NSData *) data;
- (void) didConnect;
- (void) didDisconnect;
//add v1.3


@end
